/*
 * DrvFlash.h
 *
 *  Created on: 2018/2/1
 *      Author: Robert.Wang
 */

#ifndef DRVFLASH_H_
#define DRVFLASH_H_

#ifndef E_FAIL
#define E_FAIL		1
#endif

#ifndef E_SUCCESS
#define E_SUCCESS		0
#endif

int ROM_BurnPage(unsigned int addr,unsigned int DelayTime,int* data);
int ReadWord(unsigned int addr);
int ReadPage(unsigned int addr,int* data);
int PageErase(unsigned int addr,unsigned int DelayTime);
int SectorErase(unsigned int addr,unsigned int DelayTime);

int DrvFlash_Burn_Word (unsigned int u32addr,

                       unsigned int u32DelayTime,

                       unsigned int u32data);
                       
int ROM_BurnWordonly(unsigned int addr,unsigned int DelayTime,unsigned int data);
int ROM_BurnPageWriteonly(unsigned int addr,unsigned int DelayTime,unsigned int* data);

#endif /* DRVFLASH_H_ */
